                        Regina  3.9.5
                        25 June 2022

Changes in this release (from 3.9.4)
------------------------------------
  * Bugs Fixed:
    - #266 Support tilde in Linux file names
    - #435 Regina "crashes" instead of issuing a SYNTAX error (label not found).
    - #551 leading zero in the output for time("Job")
    - #552 time("Job") does not return the CPU time used, it returns the elapsed time under Windows
    - #571 Parse Source in interactive mode crashes Regina
    - #573 tarball file issue with 3.9.4 release
    - #574 Segmentation fault on syntax error
    - #578 Crash with test for boolean using uninitalised variable
  * Changes
    - run rxstack as rxstack user not root when installing Linux package
    - Fix crash with sysgetline() if line > 260 characters.
                        Regina  3.9.4
                       25 October 2021

Changes in this release (from 3.9.3)
------------------------------------
  * Added "CALLER" as valid environment for VALUE BIF.
  * Enabled GETCALLSTACK to display to stderr if no stem argument specified
  * Rearranged build process. Package builds now self-contained
  * Support for native Apple Silicon
  * Add syshomedirectory() in regutil to get user's home directory
  * Add sysgetline() and sysgetlinehistory() in regutil to provide an interface to readline.
    This provides the ability to obtain keyboard line entry with editing and history.
    Requires readline development package installed.
  * When calling UNAME('S') under Windows 11, it will return "WIN10" as the system version.
    This is Microsoft's idea of version control!  To distinguish between Windows 10 and 11
    check that UNAME('R') is 21996 or greater.
  * Bugs Fixed:
    - #543 b2x ignores a trailing
    - #550 unary operator (in an  IF  or  WHEN  statement using an unary operator isn't being handled/processed correctly
    - #566 Typos and friends
    - #450 Time('O') jumps 2hrs for Daylight Savings Time (Breakage under Windows; daylight savings time is already included in localtime calculations)
  * Feature Requests:
    - #43 Support both AA and AC as Logical Not (Thanks Shmuel)
                         Regina 3.9.3
                        5 October 2019

Changes in this release (from 3.9.1)
------------------------------------
  * Fix for Bug #456, #463, #474, #484, #489, #490
  * Fix for Bug #311, #312, #392, #394, #422, #454, #500, #501, #508, #511, #512, #524, #525, #528, #529
  * Fixed some issues with bug #455; some still remain
  * Removal of some compilation warnings
  * Fix for syscls() under Linux
  * Changed addons dir in regina-config script to exclude prefix - breakage
  * Add optional setting of PATHEXT under Windows installer
  * Recognise Windows 10 in UNAME BIF
  * Enabled rxstack to run as a Websocket server. This allows a portable
    mechanism for other languages to use the Regina stack process; eg Javascript
  * Added .DIRSEP reserved variable for current directory separator
  * Added NOEOL option on ADDRESS...WITH INPUT.. to suppress Regina's default of
    appending EOL to each line read from the INPUT. Bug #525
  * Support ~ as first character in filenames under Un*x/Linux platforms to signify
    current user's HOME directory
  * Added 'I' option to sysfiletree() in regutil to enable files to be found
    irrespective of case
  * Add libregina.pc for pkg-config
  * Version information display via "regina -v" now goes to stdout
  * Added options to -v switch to provide more information to external function packages
    -va - displays location of Regina's addons directory
    -vb - displays number of bits for platform; eg 32 or 64
    -vv - displays Regina numeric version; eg 3.9.3
  * Added /list switch to rxqueue to list the names of the stacks held by a rxstack service
  * Added support for update-alternatives mechanism on Linux to allow Regina and ooRexx to be installed
    at the same time
  * Overhauled Linux packaging. Added Alpine Linux package support
                         Regina 3.9.1
                         5 April 2015

Changes in this release (from 3.9.0)
----------------------------------
  * Fix for Bug #396, #418, #429, #432, #434, #437, #441, #443, #449, #451
  * Feature request #37
                         Regina 3.9.0
                       17 October 2014

Changes in this release (from 3.8.3)
----------------------------------
  * Fix for Bug #436. This allows for errors generated in the parsing stage to be trapped by
    a system exit.
                         Regina 3.8.3
                       22 September 2014

Changes in this release (from 3.8.2)
----------------------------------
  * Finally a fix for Bug #429
  * Fix for Bug #433
  * Added extra QUERY options; CREATETIME, MODIFYTIME and ACCESSTIME to STREAM BIF
    Returns a time_t value for create, modify and access time of the persistent stream
    Feature Request #34
  * Feature Request #35 - GETCALLER BIF to determine who called the program
  * Feature Request #36 - .FILE reserved variable
                         Regina 3.8.2
                         22 June 2014

Changes in this release (from 3.8)
----------------------------------
  * Fix for Bugs #429, #430, #387
  * Add extra level of versioning to enable quicker releases when minor fixes corrected.
                          Regina 3.8
                         04 June 2014

Changes in this release (from 3.7)
----------------------------------
o Fix for Bugs #390, #412, #403, #397, #417, #415, #421, #420, #427, #407, #420, #389, #426
o Fix for bug #419 - conversion from TIME('T') and DATE('T') now returns local time as
  per documentation. Previous versions returned UTC time, so this change may cause breakage!!
o Moved all native language error messages into *.mts files. *.mts files now stored as UTF-8
o Error messages returned as a result of processing a native language file will be in English
  as it is not possible to store UTF-8 strings in source code in a portable manner.
o Added new logical not operator; ¬ (hex value 'AC'x)
o Windows installer now allows 32bit and 64bit versions of Regina to be installed on the one machine.
o Consistency with common switches for all executables. Long options also supported.


                          Regina 3.7
                        14 October 2012

Changes in this release (from 3.6)
----------------------------------
o Significant performance improvement with LINES BIF on large files; fixes bug 2663478.
o Significant performance improvement with compound variables with large numbers of tails; bug 2496099.
o TRACE L now traces internal subroutines called as functions. Regina used to
  only trace internal subroutines if they were called by CALL. Still some
  indenting issues. Bug 3564529.
o Added -o command-line switch to specify OPTIONS
o Update usage from 'rexx -h' and man page
o Fix bugs: 3089351, 3143101, 3175984, 3265645, 3376604, 3386045, 3511119, 3520068, 3524887, 3522738,
  3531785, 3531812, 3539337, 3564585, 3560639, 3564570, 3564507, 3565673, 35655582, 2941670, 3489133,
  1887965, 3037156, 3170743, 3400513
o Closed/Rejected bugs: 2873709, 2902600
o Implement date separator conversions in DATE BIF as per Object Rexx. Feature request #463689
o Added support for trigonometric functions in Regutil package
o Windows installers now defaults to install into %programfiles%\rexx.org\Regina
o Windows installers now uninstall only the files that are installed.
o This version of Regina now runs under Windows 2000; v3.6 did not.
o Added stubs for API functions; RexxSetTrace and RexxResetTrace.
o Added code to support RexxSetHalt API function

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  mark@rexx.org  http://www.rexx.org/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL, Rexx/CURL, etc.
* Maintainer of Regina Rexx interpreter
* Use Rexx? join the Rexx Language Association: http://www.rexxla.org/
------------------------------------------------------------------------
                          Regina 3.6
                        31 December 2011

Changes in this release (from 3.5)
----------------------------------
o Fix for bugs 1412724, 2926274, 2927338, 3043962, 3077291, 3143104, 3103021,
  3084956
o Fix for documentation bugs 3143008, 3143009, 3143016, 3143022, 3143046,
  3143060, 3143066, 3143073, 3143090, 3143230, 3001486, 3084948, 2997212,
  2992527, 2995002, 3003063, 3005806
o Debian packages available
o Regina now runs on Haiku operating system.
o Increase maximum length of source line to 100000 characters.
o Better support for building static/dynamic modules.
o Support for Large Files (> 4gb) with STREAM BIF and SYSFILETREE on
  some 32bit Operating Systems
o Implement Feature Request: 2994417 - add SINGLE_LINE_COMMENT option
  to allow the Regina single line comment (--) to parse as equivalent to +.
o Add new BIF: GETCALLBACK. Populates an array with the call stack within the
  program.
o Add optional parameters to REGSTEMREAD to return minimum and maximim length
  of a line in the file being read

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  mark@rexx.org  http://www.rexx.org/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL, Rexx/CURL, etc.
* Maintainer of Regina Rexx interpreter
* Use Rexx? join the Rexx Language Association: http://www.rexxla.org/
------------------------------------------------------------------------
                          Regina 3.5
                        31 December 2009

Changes in this release (from 3.4)
----------------------------------
o Fix for bugs 1878071, 1913282, 1898218, 1966080, 1745572, 2727006
o Error 94.1 added
o MacOS X universal binaries supported
o Add support for NOTREADY condition on external queue timeout
o Enable .LINE special variable to return a correct value in instore macros
o Add .ENDOFLINE special variable
o Added Svenska local language courtesy of Jan-Erik Larka
o Support for building RPMs without dependencies on Regina
o Fix the name of fileds in API RXMSQPSH_PARM structure
o Attempting to set a variable using RexxVariablePool() starting with a
  period will result in a return code of RXSHV_BADN.
o Incorporated Patrick McPhee's Regutil package as part of Regina. Michael
  Green contributed much of the OS/2 port of Regutil plus the trigonometric
  functions equivalent to those found in ooRexx.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  mark@rexx.org  http://www.rexx.org/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL, Rexx/CURL, etc.
* Maintainer of Regina Rexx interpreter
* Use Rexx? join the Rexx Language Association: http://www.rexxla.org/
------------------------------------------------------------------------
                          Regina 3.4
                        30 December 2007

Changes in this release (from 3.3)
----------------------------------
o Fixed bugs 918739, 952229, 952380, 961301, 972850, 982062, 995505, 1000227,
  1009248, 1021823, 1026572, 1107760, 1116894, 1107763, 1107759, 1107969,
  1109296, 1112956, 1113373, 1785707, 1712212, 1473767, 1291453, 1230639,
  1207412, 1204343, 1198965, 1180098, 1179167, 1116721, 1112677, 1112676,
  1112668, 1111931, 1111339, 1109372, 1109335, 1108868, 1100224
o Cygwin port will now return "UNIX" as the first word from
  PARSE SOURCE
o The default behaviour of LINEOUT(fn) has reverted back to the
  "normal" behaviour. It now behaves as a "close" of the file.
  If the STRICT_ANSI OPTION is set, it will NOT close the file.
o Regina now has support for error messages in Turkish; thanks to
  Haluk Polat
o Fix crash bug with DATE() and TIME() converting to type 'T' when date/time
  is negative.
o Improved speed of SUBSTR() BIF courtesy of Julian Onions
o Another 32-bit DOS port using OpenWatcom's DOS4G
o Better VMS support courtesy of Bernard Giroud
o Fixed minor memory leak with ADDRESS WITH
o Better support for MinGW compiler
o Builtin external libraries with static dynamic loading now displayed
  with -v command line switch to "regina" executable
o "threader" test program can now be used as a harness to test thread-safe
  Rexx programs
o ADDRESS BIF now correctly reports more details when an option of I, O or
  E is passed. This is now correct ANSI behaviour.
o Preliminary support for large files (ie > 4gb)
o Performance of large stems significantly improved.
o Use of 64bit time functions on Win32 allows negative time_t values
o EPOC32 port now builds again.
o Added PUTENV BIF to enable environment variables to be deleted.
o Changed syntax of LOWER and UPPER BIFs, to have similar arguments to
  SUBSTR. It is now possible to lower/upper case portion of a string.
o On Un*x platforms where GCI is supported, including GCI is now the default.
  If you DON'T want GCI included, configure with: --disable-gci switch
o The default type of function pointers to API functions is now
  "strongly" typed as the default. To use "weak" typing, #define
  RX_WEAKTYPING. (API developers only need to take note of this)
o Changes to allow Regina to be built with a C++ compiler.
o Fixed bug with QUALIFY BIF. Now works correctly when file does not exist.
o Added 'I' ISO DATE BIF format option.
o Documented 'J' TIME BIF format option.
o Added Object Rexx line comment; "--" based on code from Robert Hodge.
o Added .LINE reserved symbol which provides the line number of the current file
  based on code from Robert Hodge.
o Builds as native 64bit application on Windows XP 64bit.
o GCI builds under Cygwin.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  mark@rexx.org  http://www.rexx.org/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL, Rexx/CURL, etc.
* Maintainer of Regina Rexx interpreter and Rexx/Tk
* Use Rexx? join the Rexx Language Association: http://www.rexxla.org/
------------------------------------------------------------------------
                          Regina 3.3
                        25 April 2004

Changes in this release (from 3.2)
----------------------------------
o Integration of Florian's Generic Call Interface (GCI) into Regina.
  Supported platforms to date are Windows, OS/2 and Linux.
o Fixed bug with TRACE F and its "conversion" into "N" on a subsequent call
  to TRACE BIF.
o Addition of Polish native language support courtesy of Bartosz Kozlowski.
o PARSE LOWER and PARSE CASELESS added.
o Major changes to EXIT handling
o Regina determines internal and external queues by the fact that external
  queues MUST have a '@' in the name. Therefore any time a queue name is
  used; in RXQUEUE or ADDRESS...WITH, then if the queue name has a '@'
  then Regina treats this as an external queue, and requires the RXSTACK
  server to be running.
o New BIF POOLID. Allows the current variable pool number to be obtained
  (effectively the level of called subroutines).
o VALUE BIF allows environment to be a number corresponding to a variable
  pool number. Therefore unEXPOSEd variables in any subroutine can be accessed.
o API functions Rexx*Dll() now implemented.
o Locale support for BIFs like TRANSLATE now supported, and can be overridden 
  from command line. (-l switch)
o Algorithm for determining where a Rexx program is (either from command line, or
  a CALL statement called.  Apart from a change in the precedence of directories
  an environment variable REGINA_SUFFIXES is used to supplement the file extensions
  that Regina uses to append to the passed file name. More details can be found in the
  Regina documentation.
o Regina OPTIONS can now be specified as an environment variable, which will set the
  default values for OPTIONS. The OPTIONS instruction can still be used and will
  override the defaults.
o A new OPTION has been added; CALLS_AS_FUNCS to allow programs that use the non-ANSI
  format of "CALL label(arg1,arg2)". Although this is implemented as an OPTION, it can
  only be set via the REGINA_OPTIONS environment variable!
o Another new OPTION; QUEUES_301 to duplicate the behaviour of Regina queues; both 
  internal and external.
o Some memory leak fixes with INTERPRET and some "handle leaks" under Windows fixed.
o Initial support for SkyOS
o Fixed some old bugs: (documented in BUGS file)
  19991216-29512, 20000319-63722, 36

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                          Regina 3.2
                        25 April 2003

Changes in this release (from 3.1)
----------------------------------
o Changed the problematic building of thread-safe shared libraries introduced 
  with 3.1.
  Building of separate libraries for the single-threaded and thread-safe shared 
  libraries WAS meant to make things easier, but it made things worse. So, 
  only one shared library is ever built. If threads are supported, the Regina
  shared library is thread-safe. If threads are not supported, then the Regina
  shared library is single-thread only. PARSE VERSION will identify whether the
  interpreter is thread-safe or not.
  Win32, OS/2, Linux, Solaris, FreeBSD will have thread-safe shared libraries
  built by default.
o Builds on Unix platforms with gcc no longer use soname for the shared library.
o Fixed bug 722717 - Regina not handling string constants correctly in loops,
  if the strings are valid numbers.
o Fixed bug 724390 - Incorrect parsing of strings like '003'x1
o Fixed crash with CRYPT BIF under Windows.
o Documented threader.c sample program.
o Error handling is now thread-safe.
o Reduced memory leak with thread-safe library.
o Added --disable-posix-threads to NOT build the thread-safe version of
  libregina.so on platforms where the default is to build the thread-safe
  version.
o Changed the behaviour of LINEIN to be more consistent with Object Rexx.
  Regina will now treat a line as any string of characters that ends in
  CRLF, LF, or CR on all platforms.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 3.1
                        5 April 2003

Changes in this release (from 3.0.1)
------------------------------------
o Changed behaviour of non-strict comparitors WRT white space. In previous
  versions of Regina a variable containing say, only spaces and one containing
  only tab characters, would be equal in a non-strict comparison like "=".
  ANSI 7.4.7 states that only spaces (ASCII x20) are stripped from the expressions
  on each side of the comparitor. With OPTIONS STRICT_ANSI the ANSI semantics are
  always used. A new OPTION; STRICT_WHITE_SPACE_COMPARISONS, has been provided
  to enable the new ANSI behaviour, without being restricted by all the other STRICT_ANSI
  limitations. It is recommended that code be changed and tested with
  STRICT_WHITE_SPACE_COMPARISONS as future versions of Regina will
  default to the ANSI behaviour. Reported in SourceForge bug 594674.
o A new feature called "static dynamic loading" has been included.  This feature allows
  supported external function packages to be statically linked when building Regina.
  This serves two purposes: 1. where the underlying operating system does not support
  dynamic loading of executable code; eg QNX4, DOS, and 2) where it is desirable to
  ensure that a particular version of an external function package is being used.
  See README.STATIC for more information on this.
o When building Regina from source, the thread-safe version of the Regina shared
  library (or DLL) is always built where the thread-safe version is supported. The
  thread-safe version of the Regina library will be named; libregina_ts.so or reginats.dll
  depending on the platform.
o Mac OSX is now fully supported WRT dynamic loading of external function pacakges. See
  README.MacOSX for more details.
o The memory debugger; Electric Fence can now be used when building debug the version
  of Regina on Un*x platforms. Use --enable-efence as a parameter to configure script.
o ADDRESS WITH should now be fully functional. External queues can also be addressed
  in WITH FIFO/LIFO clause.
o SourceForge bug numbers fixed: 481482, 499163, 554384, 574683, 577401, 577634, 592393,
  595293, 594553, 653214, 657345, 656356, 646902, 657377
o SEEK relative (forwards) now works in STREAM BIF.
o You can now create and execute tokenised Rexx code from the rexx and regina executables.
  See the -c and -e command-line switches.
  Removed reginac and rexxc executables as they are no longer required.
o Clean up rexxsaa.h and remove EXIT typedef.
o ADDRESS WITH OUTPUT or ERROR STEM no longer raises a NOVALUE condition.
o Descriptions of errors via STREAM( fn, 'D' ) under Win32, now return more
  meaningful errors.
o The LOSTDIGITS condition has now been implemented. This is the last major item specified
  in the ANSI Standard that Regina did not support. As a result, the supported language
  level of Regina (as reported in PARSE VERSION) will now report 5.00.
o Fixes for building under HP-UX and AIX.
o With the addition of LOSTDIGITS, Regina now supports Rexx Language Level 5.00; ie
  ANSI.
o Addition of RexxCallBack() API function. This API call allows an API program to call
  an internal procedure in the currently running Rexx program, with parameters and to
  return a value to the API application.
o Finished ADDRESS WITH to support FIFO/LIFO (Florian)
o rxstack and rxqueue rewritten (Florian)
o Add support for statically linking external function packages.
  Platforms that don't support dynamic loading capabilities can now
  statically link external function packages (provided they offer the
  support). Most useful on platforms like QNX4, DOS.
o Staf Verhaegen added many ARexx BIFs:
  B2C,BITCHG,BITCLR,BITCOMP,BITSET,BITTST,C2B,COMPRESS,EXISTS,EXPORT,FREESPACE,
  GETSPACE,HASH,IMPORT,RANDU,READCH,READLN,SEEK,SHOW,STORAGE,TRIM,UPPER,WRITECH,
  WRITELN. These are available by default on Amiga and AROS, but to use these
  new BIFs on other platforms you need to specify the AREXX_BIFS OPTION.
o Added new OPTION; AREXX_SEMANTICS. This specified that the ARexx semantics for
  the OPEN, CLOSE and EOF BIFs should be used rather than the old Regina semantics.
  As the old Regina BIFs, OPEN, CLOSE and EOF have been deprecated in recent version
  of Regina, a future version of Regina will remove this new option and the ARexx
  semantics will become the default.
o Regina's parsing code has been cleaned up.
  ***** Breakage Alert *****
  One of the most significant changes is that the valid Regina syntax of: 
  CALL FUNC(a,b) is now invalid. 
o All options of STREAM SEEK should now be functional.
o Added new OPTION; BROKEN_ADDRESS_COMMAND to cater for code written for
  other Rexx interpreters that have a "broken" implementation of ADDRESS
  COMMAND (or CMD), that assumes that internal command processor commands
  can be run by ADDRESS COMMAND. With this OPTION set, Regina treats ADDRESS
  COMMAND (or CMD) the same as SYSTEM.
o Also merged PATH and CMD/COMMAND environments for ADDRESS. Now all 3 work the
  same as ADDRESS PATH.  What this means is that the executbale to be run, will
  be looked for in the PATH environment variable, instead of the full path to the
  command having to be specified.

Changed in 3.0.1 (windows release)
----------------------------------
o Changed "pause at end" behaviour. Now need to specify -p switch if you want
  the "pause at end" message to appear.
o Fixed bug with Win9x/WinMe not running external commands correctly.
o Fixed bug with ADDRESS...WITH OUTPUT FIFO ''
o Fixed a bug with a crash of rxstack.
o Renamed rexx.1 man page to regina.1 and changed contents to reflect "regina"
o Default behaviour of Win32 Installshield package is to NOT install
  rxstack by default. Also added a security note.
o Default behaviour of Linux RPM is to NOT install machine startup/shutdown
  scripts for rxstack.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 3.0
                        25 April 2002

Changes in this release (from 2.2)
----------------------------------

o Fixed a bug with a crash under Win32 when trying to load a function
  with rxfuncadd() and that function does not exist in the external function
  package.
o Added ANSI enhancements to ADDRESS command. Now supports full WITH options.
  This feature implemented by Florian Grosse-Coosmann.
o New port of Regina to EPOC32. Regina now runs on Psion 5mx/Revo/Revo Plus
  and those mobile phones that run EPOC32 operating system. The RexxStart
  package for EPOC32 also comes with an online Regina quick reference guide.
o Added -a switch to specify that separate arguments should be passed to the
  Rexx program. 
  eg without the -a switch (default behaviour of all Rexx interpreters)
     % rexx fred "this has spaces" mary
  /**/
  Parse Source . how .
  Say how     /* -> COMMAND */
  Say Arg(1)  /* -> fred this has spaces mary */
  Say Arg(2)  /* -> */
  Say Arg(3)  /* -> */
  Say Arg()   /* -> 1 */
     % rexx -a fred "this has spaces" mary
  /**/
  Parse Source . how .
  Say how     /* -> SUBROUTINE */
  Say Arg(1)  /* -> fred */
  Say Arg(2)  /* -> this has spaces */
  Say Arg(3)  /* -> mary */
  Say Arg()   /* -> 3 */
  You can determine how the Rexx program was called by checking the
  second word in PARSE SOURCE as the above example shows.
o Add regina-config creation under Un*x platforms. This is to simplify the
  determination of what flags to use to build a program that links with Regina.
o Files are now truncated properly with LINEOUT() on QNX 4.2x
o Added UPPER instruction to ease porting from those platforms that support
  the UPPER instruction.
o TRACE command now supports numeric values when in interactive trace. TRACE with
  a positive whole number will execute the number of clauses using the current TRACE
  setting without any prompting. TRACE with a negative whole number will execute the
  number of clauses without prompting, and with a temporary TRACE O in effect. TRACE 0
  is the same as TRACE O.
o Added 'T' option to TIME and DATE BIFs to return the current Unix time_t value.
  'T' format can also be used in time and date conversions.
o Slight change of behaviour when Regina looks for external functions in
  directories PATH. Regina will no longer look for an external function
  without an extension.  This is to allow Regina to allow operating system
  commands to be called as functions: eg. a = 'ls'() will now work as it did
  before the change to search PATH as well as REGINA_MACROS. If you have an
  external routine called 'ls.rexx' in PATH, it will still find it!
o Added new OPTION: STRICT_ANSI (replaces ANSI OPTION). If you specify STRICT_ANSI
  in an OPTIONS statement, Regina will disallow any Regina functionality that is
  not part of the ANSI standard. (This is an ongoing exercise).
  Restrictions currently implemented:
  - C and T options on DATE BIF
  - J and T options on TIME BIF
  - BIFs not allowed: 
    ALLOCATED,BEEP,BUFTYPE,CD,CHDIR,CLOSE,CRYPT,DESBUF,DIRECTORY,DROPBUF,DUMPFILES,
    DUMPTREE,DUMPVARS,EOF,All VMS F$ functions,FILESPEC,FIND,FINIS,FORK,FREELISTS,
    GETENV,GETPATH,GETPID,GETTID,INDEX,JUSTIFY,LISTLEAKED,MAKEBUF,MEMORYSTATS,OPEN,
    POPEN,SLEEP,STATE,TRACEBACK,UNAME,UNIXERROR,USERID
  - Instructions not allowed:
    UPPER
    ADDRESS (env)
  - Treating operating system commands as functions. eg: a = 'ls'() will
    return an error 43.1.
o Initial native language support added. This release allows for error
  messages to be displayed in a user-selectable native language.
  All native language error messages are contained in binary files (*.mtb) that
  are built with the Regina executables from source files (*.mts).
  The mechanism Regina uses to determine what native language to use to display
  error messages depends on the operating system. 
  On EPOC32, the language is supplied when installing; the selected language
  is contained in default.mtb.
  On all other platforms, Regina uses environment variables if you want to use a
  language other than English. The English messages are built into the interpreter.
  Up to 2 environment variables are used. 
  REGINA_LANG environment variable can be set to an ISO 639, 2 character
  language abbreviation as defined below. 

  Abbrev Language       Translation By             EPOC32?
     de  German         Floran Grosse-Coosmann        Y
     es  Spanish        Pablo Garcia-Abia             Y
     no  Norwegian      Vidar Tysse                   Y
     pt  Portuguese     Susana and Brian Carpenter    Y
  
  If REGINA_LANG is not set, the default is "en".

  REGINA_LANG_DIR is required if Regina does not know where the language files
  will be at runtime.
  Any binary distribution that includes an installation routine; RPM, Windows
  InstallShield or EPOC32, will set the location of the .mtb files automatically. 
  Similarly building and installing Regina on Unix-like platforms using 
  configure;make install combination will also set the location automatically.  
  All other platforms will require this environment variable to bet set manually.
o Continuing addition of more sub-error reporting.
o Added new command to RXQUEUE() BIF; TIMEOUT.  This allows the setting of a timeout
  value on an external queue, so that a subsequent PULL from the queue can be made
  to timeout after a certain period (specified in milliseconds), or wait indefinitely
  (specify a timeout of 0).
o When a Rexx program is run from the Win32 Explorer or from the Start->Run prompt,
  Regina will display a prompt and require the user to press ENTER to close the
  console window. This is to allow the output from the Rexx program to be seen.
o Added binaries to create and execute tokenised code files. 
o Fixed a crash with some combinations of compound variables, and minor bug
  with TRACE. Fixed by Mark Wooding
o Interactive tracing state now correctly remembered across subroutine
  calls. Fixed by Mark Wooding
o Changed error reporting of unmatched comments, as per feature Request:
  #508788. Error message now reflects comment starting line rather than
  end of file line.
o Added '.rx' as a recognised file extension.
o Fixed bug with negative values passed to TIME BIF.
o Added capabilities to run Regina in "safe" mode.  This mode is useful for
  running in an environment where the Rexx program should be
  prevented from changing the environment in which it is running. eg as a
  database procedural language. See README_SAFE for more information.
o Added new builtin environments: REXX and REGINA, to allow Rexx programs
  to be run in another process.
o Fixed bug with rxstack when using timeouts on queues, and with deleting
  lines off the queue when they are pulled off.
o Fixed bug with FORK BIF on unsupported platforms.  It now correctly returns 1
  instead of 0 if FORK unsupported.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 2.2
                        17 June 2001

Changes in this release (from 2.1)
----------------------------------

o Added multiple, named queues designed to be compatible with OS/2
  Rexx, but also provides cross machine/platform capabilities. ie
  you can push lines on a named queue on say Linux, and pull them
  off that queue from a Rexx program running under Windows.
  Provides the BIF rxqueue(), the external stack server; rxstack, and
  the external client application; rxqueue. rxstack is designed to run
  as a daemon process on Unix platforms, and an NT Service under NT/2k.
  Other platforms can run rxstack as a normal foreground program.
o Updated documentation to version 2.2, to include changes from
  0.08e up to 2.2. Base documentation now in StarWriter 5.2 format
  rather than MS Word.
o Fixed bug with input/output redirection on non-Unix platforms.
  ie '>LIFO sort >FIFO' now works correctly.
o Changes to rexxsaa.h to allow MingW32 compiler to link with VC++ built
  regina.lib
o Addition of SAA API calls; RexxCreateQueue(), RexxDeleteQueue(),
  RexxAddQueue(), RexxPullQueue() and RexxQueryQueue().
o Addition of Rexx Macro Space functions. These are stubs at the moment.
o To comply with the File Hierarchy Standard (FHS), Regina program
  files are installed, by default on Unix systems, in /usr directory, 
  rather than /usr/local.
  eg. /usr/bin/regina rather than /usr/local/bin/regina
  To achieve the same behaviour as previous releases, 
     configure --prefix=/usr/local
o Removed UNION_EXIT #define in rexxsaa.h. This was baggage from old
  versions of Regina, and is now not supported.
o Win32 port now packaged as self-extracting InstallShield package.
o Change to RexxStart() API function. When specifying a default environment
  that is an internal environment, don't add a new one, but use the details
  of the existing internal environment. This allows OS commands to be run
  correctly.
o Fixed the non-random bug with RANDOM BIF on non-Unix platforms. (Paul Barnett)
o QNX RTP support added.
o Fix for excessive copying of parameters for most BIFs. Speeds up functions
  like LEFT and SUBSTR as reported by Dennis Baeris and others.
  (Paul Barnett)
o Internal change: save currentnode across calls to interpret() (Paul Barnett)
o Minor change to code to cleanly build on Mac OS X.
o Environment variable PATH now also used to find Rexx programs from the
  command line and externally called programs.
o Added new system exit handler; RXENV and subhandlers; RXENVSET and RXENVGET.
  These system exits are called when the VALUE BIF is called to get or
  set a variable in the external environment as opposed to the Rexx
  variable pool.
o Partial AtheOS port.
o Added -v switch to Regina executables to display Regina version string.
o UNAME BIF now reports correct Windows operating system name.
o Full support for building Regina under Win32 Cygwin environment including
  building DLLs.
o Win32 Binary distribution now comes with import libraries for Cygwin,
  Borland and MingW32 compilers.
o Initial attempt of port to MacOS 8.1+ 68k.  Doesn't work yet!
o Minor changes to allow Regina to run on 64bit machines.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 2.1
                         26 Jun 2000

Changes in this release (from 2.0)
----------------------------------

o Fixed bug with CALLing external routines with parameters; eg
  CALL "extrout" parm1
  This was supposed to be in 2.0
o Minor changes to text of error messages to be consistent with ANSI
  standard.
o Fixed minor bug in UNAME BIF.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 2.0
                         13 Mar 2000

  The version numbering of Regina has changed.  Anders' original intent
  was for Regina to be released as version 1.0 when it achieved
  100% ANSI Compliance.  I originally concurred with this approach
  by releasing the 0.08 series, but with this release, Regina has
  changed internally sufficient to warrant a major version number
  change.  By continuing to release version numbers of 0.xx, the
  implications are that Regina is not a mature product. Obviously,
  this is not the case, and rather than confuse the situation and
  release a version 1.0, version 2.0 was decided upon.
  Anders is aware of the change and is happy with the change
  provided there is no confusion with users. Hopefully that isn't
  the case.

Changes in this release (from 0.08h)
------------------------------------

o Added thread support. Support available for platforms that use
  Posix Threads, Win32 threads and OS/2 threads.  This is the first
  version of Regina with thread support, so don't expect a flawless
  implementation yet. 
  Platforms that are known to work:
  - Linux RedHat 6.1
  - Windows NT/98/2000
  - Solaris 2.5 using gcc
  Platforms that are known not to work:
  - Linux RedHat 5.1 - threads library too old
  - Digital Unix 4.0 - compilation errors
  OS/2 thread support is only available with EMX, and that hasn't
  been tested thoroughly.
o A new sample program; threader, has been written to demonstrate
  Regina's multi-threading capabilities.
o This version now includes support for Linux/390 and BeOS.
o Removed limitation on maximum value of NUMERIC DIGITS. Now no
  effective limit.
o Regina now returns a tokenised version of a Rexx program via
  RexxStart() that can be re-loaded from another session.
  Tokenisation, without execution, passing '//T' as the first
  program parameter in RexxStart() also works.
o Regina can now be built on the Amiga with gcc.
o Fixed "groundhog day" bug with TIME('L'), where times at .5 second
  would be rounded up to the next second.
o Regina's stack usage has been dramatically reduced.
o Removed limitation of nested functions and loops. Now no effective
  limit.
o Reduced common global symbols in the library. Reduced symbols
  in shared libraries (ELF format) and DLLs.
o Changed the method for Unix installation. Should now work on all
  Unix platforms.
o Fixed bug with CALLing external routines with parameters; eg
  CALL "extrout" parm1
o Fixed bug with EXIT expr and RETURN expr, where expr was non-numeric.
o STREAM subcommand SEEK, now behaves like Object Rexx.
o Regina can now be built on Win32 platforms with the free Borland C++
  5.5 compiler. Thanks to Dan Sharp for the patches.
o RANDOM BIF would return a maximum value of 32767 on most platforms.
  Now returns up to 100000.
o A new make target for Unix platforms; 'make binary' builds a binary
  release of Regina. You must have gzip installed for this to work properly.

Once again Florian Grosse-Coosmann has made the majority of the 
contributions to the success of this release. 

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 0.08h
                         24 Dec 1999


Changes in this release (from 0.08g)
------------------------------------

o Fixed bug with NOTREADY condition at end of file.
o Fixed bug with LINES() not returning 0 at end of file.
o Fixed typo in rexxsaa.h for C++ programs.
o Fixed bug with inconsistent treatment of TRACE commands in instore
  macros.
o Fixed DOS/DPMI port (DJGPP) which failed to allow PARSE PULL to echo
  characters typed.
o Added MingW32 compiler support.
o Changed return value of CONDITION('D') to comply with the ANSI standard.
  The return value of CONDITION('D') when called from within the
  condition handler, returns the fully expanded text of the suberror. ie
  the same string (excluding the "Error n.n" prefix) as would be
  displayed if the condition was not trapped. When CONDITION('D') is
  called from outside a condition trap will still return the empty string.
o Fixed bug with STREAM sub-errors not being displayed.
o Changed behaviour of STREAM(stream,'S') to return READY even though
  the last LINEIN or CHARIN read the end of file.  This change is to
  make Regina more consistent with other interpreters. STREAM(stream,'S')
  will return NOTREADY only after an attempt has been made to read after
  EOF.
o Remove calling of ranlib when installing libregina.a on AIX.
o Added some more sub-error text messages for TRACE and NUERIC FORM/DIGITS.
o Reverted a "fix" in 0.08g;
  "Fixed bug in RexxVariablePool API when retreiving a Rexx compound variable
   that has a mixed or lower case stem value.  This same bug is in OS/2 Rexx!"
o Changed a couple of the programs in the trip directory to conform with
  the ANSI standard and the changes made in Regina.
o Fixed bugs 19, 27, 29, 30, 31, 33 and 34 as described in BUGS file.
o Fixed bugs 32, 35 and 19991129-86098 as described in BUGS file.
o FORMAT BIF now more compatible with ANSI standard.
o Changes to RexxAllocateMemory() and RexxFreeMemory() API calls.
  These functions now use the system-specific memory allocation and
  freeing functions rather than malloc()/free(). This was necessary
  because sometimes the memory returned was relocated, causing a
  segmentation fault.  Also the memory allocated by the interpreter
  for return values > 256 characters from functions and the return data
  from RexxVariablePool() now use the system-specific memory allocation
  routines.
  You are strongly advised to use these functions instead of allocating
  and freeing memory using the native memory allocation/deallocation
  routines.
  Thanks to Jeff Glatt for pointing out this problem.
o Regina now has support for direct setting of Rexx variables via the
  API.
o Support for the Win32 Multi-threading port of Regina has been broken
  with this release.  This is because hard-coding of thread-safety
  was done in two generated files. A thread-safe Regina for all ports
  will be done for 0.08i.

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 0.08g
                          7 Aug 1999


Changes in this release (from 0.08f)
------------------------------------

o Fixed bugs as described in BUGS file.
o Added QNX port.
o Fixed sort order of results from POPEN BIF.
o DOS, OS/2 and Win32 ports now process stdin, stdout and stderr in
  binary mode. 08f only did this for Win32 platform, and only for
  stdout and stderr.
o Major change to lexical analyser; should be a bit faster.
o More changes to BIFs for ANSI compliance.
  LINES BIF now by default, returns 1 or 0 to indicate if there are
  lines remaining in the stream.  To get the actual number of lines
  (as Regina used to do), use LINES(stream,'C').
o ERRORTEXT now allows for decimal arguments to generate sub-error
  message text. eg. Errortext(40.1)
o Fixed bug in STREAM QUERY DATETIME for files with timestamp in 21st
  century.
o Fixed a bug with the traceback on an error being out by one line when
  the first line of the Rexx program is the special "#!" magic number.
o Fixed a bug with repeated calls to RexxStart() API.  Regina would
  run out of file handles.
o Fixed bug with RexxRegisterFunctionExe/RexxDeregisterFunction calls.
  The deregister function wouldn't completely remove references to the
  specified external function, and the next call to register the
  same function within the same process would fail.
o Added new OPTIONS; ANSI and FAST_LINES_BIF_DEFAULT.  To get the old
  default behaviour of Regina's LINES BIF, add the following line to
  the start of your code:
  OPTIONS NOFAST_LINES_BIF_DEFAULT
  The ANSI option (on by default) includes FAST_LINES_BIF_DEFAULT.
o The STREAM BIF SEEK command is now functional.
o Fixed bug in RexxVariablePool interface which prevented getting a list
  of all variables more than once. Fixed bug in execiser.c that expected
  the previous behaviour.
o When an error is returned from the STREAM BIF, it now reports errors
  other than 2. ie the '2' in 'ERROR:2' is now replaced by the correct
  error number.
o Added DIRECTORY and BEEP BIFs of OS/2. BEEP doesn't work on all platforms.
o Added OS/2 function FILESPEC; Win32 code courtesy of Mark Stern.
o Fixed bug with checking for EOF on transient streams.
o Fixed bug in RexxVariablePool API when retreiving a Rexx compound variable
  that has a mixed or lower case stem value.  This same bug is in OS/2 Rexx!
o Changed the method of determinig a random seed for RANDOM BIF if one not
  supplied.
o Combined the thread-safe version of Les Moull into the main source
  distribution.  The thread-safe code is only implemented on the Win32
  platform and only in the version of REXX.DLL supplied by Les.
o Added new API functions; RexxFreeMemory(), to free the memory that the
  interpreter allocates in calls to RexxVariablePool() etc. and
  RexxAllocMemory() to allocate memory for passing return values longer
  than 256 characters.
o Changed behaviour of trace setting command line switches. The trace
  character specified on the command line will set the trace setting for
  the whole program and will result in all TRACE commands being ignored.
o CONDITION('E') now returns the error number that caused the condition,
  in decimal format suitable for passing to ERRORTEXT BIF. (see above)
o Regina used to raise a NOTREADY condition if the last line of a file
  was not terminated with an end-of-line (LF or CRLF).  This has now
  been changed to treat an incomplete last line as a "normal" line.
o Fixed bug with running instore macros which had internal subroutines.
  An error in parsing caused the list of labels to be lost.

Please report any bugs with this release of Regina to me.

===========================================================================
Many of the improvements in this release were done by Florian Grosse-Coosmann.
I would like to thank him for his efforts in helping to make Regina a better
interpreter.
===========================================================================

Cheers, Mark.
------------------------------------------------------------------------
* Mark Hessling,  M.Hessling@qut.edu.au  http://www.lightlink.com/hessling/
* Author of THE, a Free XEDIT/KEDIT editor and, Rexx/SQL
* Maintainer of PDCurses: Public Domain Curses and, Regina Rexx interpreter
* Use Rexx ? join the Rexx Language Association: http://www.rexxla.org
------------------------------------------------------------------------
                         Regina 0.08f
                        30 October 1998


Changes in this release (from 0.08e)
------------------------------------

o Changed the extension of Rexx external function libraries under
  AIX from .a to .so.
o Removed the messy shared library naming conventions under Un*x
  platforms.  Now, there are no symbolic links created.
o Fixed GPF bug in TIME and DATE BIFs when no third parameter was
  passed, but a second parameter was passed.
o Ignore EOF character; (^Z) in source file.
o Included changes for Amiga port using SAS compiler. Thanks to
  Stefan Haubenthal <wwwsth@sx1.hrz.uni-dortmund.de> for the port.
o Fixed a bug in PARSE command introduced in 0.08e. The last argument
  in a PARSE statement, when parsing a string into words would have
  incorrect leading space.
o Added more sub-error messages to BIFs.
o Added the ANSI standard QUALIFY BIF.
o The STREAM command QUERY POSITION had syntax errors. These have now
  been fixed.
o While the Y2K support was fixed for date conversions in 0.08e, the
  current date as returned by DATE('N') was incorrect for dates >
  31 Dec 1999.
o The value returned by CHARS BIF was incorrect especially after a
  LINEIN call.  The result was some programs would never end.
o On some platforms, if operating system command redirection was
  done using >FIFO, and the current directory was not writeable by
  the user, the command would fail. The cause is that the tmpnam()
  C library function is broken on several compilers.
  Added workaround to use environment variables, TMP, TEMP or TMPDIR.
o On platforms that did not have a C library function, alloca()
  Regina would leak memory.  This has now been fixed by inclusion
  of our own alloca() function if one doesn't exist.
o A bug in the Win95/98 command processor results in any call to
  an operating system command ALWAYS return 0, even though the
  command fails.
  This change attempts to circumvent this bug, but it can't in all
  circumstances.  If the operating system command called is an
  executable file, and there is no output/input redirection, then
  the return code from the executable program will be returned. Any
  internal COMMAND.COM command, such as COPY, will ALWAYS return 0;
  there is no way around this until M$ fix there COMMAND.COM.
  If you use JP Software's 4DOS for NT, then you will have no problems
  as it correctly returns the error from the internal command.
  Reported and fixed by Michael Sundermann
o Changed some internal #defines in rexxsaa.h. These changes will
  require a rebuild of any applications that are linked with Regina.
  This change was made to make Regina more binary-compatible with
  other Win32 Rexx interpreters.
o All references to program names within the interpreter should now
  be fully qualified. ie in errors reported and in PARSE SOURCE.
o Fixed a problem with external function packages implemented as
  shared libraries on HP-UX.  If the external function package was not
  in the current directory, Regina could not find it.  The dynamic
  loader in HP-UX does not behave the same way as on other platforms;
  ie. it doesn't look for a shared library using an environment variable.
  Regina now searches for the shared library in the directories specified
  by SHLIB_PATH.
o Fixed bug with dropping compound variables.
o Fixed bug with output of operating system command under Win32 losing
  data:
  eg: rc = 'dir'('*.txt')'
o Regina's "default" filenames; "<stdout>", "<stdin>" and "<stderr>"
  can also be specified without the angle brackets. ie "stdout",
  "stdin" and "stderr".
o Fixed bug with updating variables exposed in a PROCEDURE.
o Fixed bug with internal variable SIGL being updated prematurely.
o (0 = 0.000) is now true.
o This version now works (mostly) on OpenVMS; VAX and AXP platforms.
  Thanks to Steve Harris for most of this porting effort.
o NUMERIC FORM VALUE now works.
o Changes to trip/builtin.rexx to reflect the ANSI standard.  Changes
  made to Regina to comply with these tests.
o Bug fixed in DATE BIF conversion. Dates specified in "Normal' format
  with months of 'Dec' would not be recognised.
o Under DOS, OS/2 and W32 ports, stdout and stderr are now set to
  binary mode.  This stops the operating system from translating
  '0d'x characters (LF) into CR/LF pairs.
o Fixed bug in DATE('C'); returned with a number 1 more than it should
  have.
o Fixed bug with \<< and \>> operators.
o Increased the limit on the length of a clause to 1024 characters
  (from 512).
o Better reliability when calling nested Rexx programs.

Please report any bugs with this release of Regina to me.

===========================================================================
Many of the bug fixes in this release were done by Florian Grosse-Coosmann.
I would like to thank him for his efforts in helping to make Regina a better
interpreter.
===========================================================================

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                       Email:       M.Hessling@qut.edu.au
 PO Box 203                          http://www.lightlink.com/hessling/
 Bellara                                AUTHOR of  |  MAINTAINER of
 QLD 4507                                 THE      |    PDCurses
 Australia                              Rexx/SQL   |     Regina
                Member of RexxLA: http://www.rexxla.org/
------------------------------------------------------------------------
                         Regina 0.08e
                         26 June 1998


Changes in this release (from 0.08d)
------------------------------------

o Fixed a bug in Termination System Exit. It would not get called
  if the Rexx program uses the EXIT instruction to terminate.
o Fixed the problem in execiser where variables that have no value are
  specified in lower case in System Exits, do not return their name
  in upper case as thier default value.
o The UNAME BIF now reports more useful information when running under
  Windows NT or Windows 95.
o Fixed a couple of crash situations when LEAVEing from a DO/END loop.
  Thanks to Florian Grosse-Coosmann for supplying the fixes.
o The Regina, curses interface and demo program hanoi.rexx have been
  removed from this distribution.  They are distributed as a seperate
  package under the name Rexx/Curses.
o The BIFs LINES, CHARS, LINEIN, LINEOUT, CHARIN and CHAROUT now read
  or write to/from stdout if the first parameter is the empty string.
o The BIF POPEN now writes lines onto the stack in FIFO order rather
  than LIFO order.
o Added support for piping output of an operating system command to
  RXQUEUE.  While Regina does not have an external queue, it is possible
  to do:
  /**/
  'ls | rxqueue'
  Do While Queued() > 0
    Parse Pull line
    Say line
  End
  The above support is identical to the current >FIFO redirection
  support and is provided for portability in code (but not functionality)
o Fixed OPTIONS support. Due to the way it was implemented, OPTIONS
  would not work correctly on Intel-based machines.
o Added two extra OPTIONS keywords: EXT_COMMANDS_AS_FUNCS and
  STDOUT_FOR_STDERR.
  The first relates to Regina's default behaviour of trying to execute
  an operating system command as a function, if no internal or external
  Rexx program is found.
  The second relates to Regina's default behaviour of sending error
  messages and trace output to stderr.
o Added new switches for configure script; --enable-tracemem and
  --disable-flists. Both of these switches are really only useful for
  people debugging Regina itself. Similarly when building on other
  platforms that use 'make' directly, the equivalent switches are:
     TRACEMEM=Y    - Do memory tracing (only valid with DEBUG=Y)
     FLISTS=N      - Turn off use of Regina's memory management
  The DEBUG=Y switch under EMX also sets -fbounds-checking
o Fixed and enhanced the debugging functions; dumptree() and dumpvars().
o Fixed a bug with passing a variable to a function (not modified with
  PROCEDURE keyword) and changing its value within that function.
  Thanks to Florian Grosse-Coosmann for supplying the fixes.
o Added a new file to the distribution; BUGS. This gives examples of
  code that can cause Regina to crash or produce the wrong results.
o Fixed a bug with the EMX ports of Regina, that returned the full
  filename from STREAM( filename, 'C', QUERY EXISTS) without the drive
  specification and forward slashes instead of back slashes for directory
  seperators.
o Fixed a problem with specification of single-character arguments to
  BIFs like STRIP().  The ANSI standard appears to allow any string in
  these cases as long as it starts with the appropriate character.
  <<< I'm not so sure about this now! >>>
o Fixed an error with STREAM BIF: stream(filename,'C','APPEND') would
  not append. stream(filename,'C','OPEN WRITE APPEND') works fine.
o The OS/2 EMX port now builds regina.exe, regina.dll and the sample
  test?.dll(s) for the dynfunc.rexx sample program.
o Changed PARSE SOURCE output to suppress the fourth value. This was
  inconsistent with the ANSI standard and caused problems for programs
  that used the third value, expecting spaces in the file name,
o Under DOS, OS/2 and Win95/NT, all files were opened in text mode. This
  caused a problem with CHAROUT(filename,"line 1" || '0a'x), where the
  line-feed character was being converted into a CR and LF. All files now
  read in binary mode.
o Regina now expects a new format for the name of external function
  libraries under Unix. Prior to this release, Regina would take
  the second parameter passed to the RXFUNCADD() function literally.
  The sample external function packages built with Regina were named
  test1.rxlib and test2.rxlib.  The sample program; dynfunc.rexx then
  required a test of platform to determine what the name of the external
  function package was.  Regina now follows the way that Object Rexx
  determines the name of the external function library. Thus, the
  "test1" external function package has a file name of the form:

     lib<name>.<shl>

     where:  lib    - "standard" Unix library prefix
             <name> - the name of the external function package
             <shl>  - the suffix used for shared libraries for a
                      particular Unix variant

  Thus the "test1" external function package is called:

     libtest1.sl  - HPUX
     libtest1.a   - AIX
     libtest1.so  - All other Unix variants.

  One other thing to be aware of.  The name specified in the RXFUNCADD()
  function; paramter 2 IS CASE SENSITIVE.  Thus if you specify:

     Call RxFuncAdd('Test1LoadFuncs', 'TEST1', 'Test1LoadFuncs')

  Regina will look for libTEST1.<shl>
o Fixed bug with STREAM BIF; stream(filename,'C','OPEN') would fail.

Please report any bugs with this release of Regina to me.

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                 Email:             M.Hessling@qut.edu.au
 PO Box 203                    Phone:                    +617 3802 0800
 Bellara                          http://www.lightlink.com/hessling/
 QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 Australia                     ************* Author of THE ************
+------------------------------------------------------------------------
                         Regina 0.08d
                         26 March 1998


Changes in this release (from 0.08c)
------------------------------------

o Rexx programs are now searched for, using a combination of the
  REGINA_MACROS environment variable and the addition of filename
  extensions.  This rule applies to both external function calls
  and operating system command line arguments.
  Assume you have a call to an external function, and it is coded as
  follows:
     Call myextfunc arg1, arg2
  First, Regina looks for a file called "myextfunc" in the current
  directory. If it can't find that file, it looks in each directory
  specified in the REGINA_MACROS environment variable for a file called
  "myextfunc". If the file is not found, Regina then attempts to find a
  file called "myextfunc.rexx" in the current directory, then in each
  directory in REGINA_MACROS.  Regina continues, next by appending
  ".rex" to the supplied external function name, and lastly by appending
  ".cmd".
  Only if a file does not exist in either the current directory, or
  any directory in REGINA_MACROS, either with the supplied filename or
  with that filename appended with ".rexx", ".rex" or ".cmd" does Regina
  complain that the external function is unknown.
o External function names with embedded spaces would be truncated at
  the first space. This has now been corrected.
o Applied some patches from Bernard Antoine to reduce memory leaks.
o Fixed a couple of memory leaks and a couple of crash situations.
o Added support for the "strict" operators >>, <<, >>=, <<=, \>> and
  \<<.
o Added support in the API for system exits for subcommands.
o The configure script has been changed in this release to better
  work out how to build shared libraries.
o Another change in the configure script is the --enable-tracemem
  switch.  This enables the internal memory tracing of Regina.
o Fixed a problem with calling external routines from within an
  internally called routine. See the test suite of of
  goober/IDIOT/TESTFUNC (courtesy of Chuck Moore).
o Added the "QUERY" commands for the STREAM() BIF.
o Added the "OPEN" commands for the STREAM() BIF.
o The DOS and OS/2 ports of Regina can now use operating system commands
  in function calls. eg rc = fred('parm1')  where fred.exe is an
  executable somewhere in the PATH.
o A bug has been fixed when pushing lines > 512 characters in length
  onto the stack from an external program running under OS/2, DOS or
  win32.
o Some progress has been made on displaying more detailed error messages
  (as per the ANSI standard) after the "normal" Rexx error messages.
o One of the header files that Regina uses (sys/stat.h) has been broken
  on RedHat Linux 5.0. The only effects, hopefully, that you should see
  are some compilation warnings when compiling files.c.
o A change has been made in the API function RexxVariablePool(). The
  SAA API documentation specifies the following when fetching the
  value of a variable from the interpreter:
  "On return, shvvalue.strlength will be set to the length of the
   returned value; shvvaluelen will be unchanged."
  In previous version of Regina the above condition was met, but the
  actual situation with IBM OS/2 REXX, is the reverse; shvvaluelen is
  changed, but shvalue.strlength remains the same.  Quercus Systems
  Personal Rexx and Enterprise Rexx follows the IBM OS/2 REXX behaviour.
  IBM's Object Rexx however, changes both values.  Regina now follows
  Object Rexx's behaviour, as this will allow programs written to the
  OS/2 REXX behaviour to work with Regina.
o Several changes in the API have been made that will require any
  programs linked to previous versions of Regina to be rebuilt. The
  main change was in the number indicating how the interpreter is
  invoked.  These changes were done to bring Regina in line with other
  interpreters.
o The curses interface for Regina has been enhanced, to include support
  for colour (that's how I spell it!) and support for creation of curses
  windows.  This release will be the last to include the curses
  interface as part of the Regina distribution; I will be distributing
  it as a seperate product in future.  See the updated version of
  hanoi.rexx for examples of some of the new features.
o Some corrections were made to the DATE() BIF, particularly in the
  day of the week conversion, and Y2K changes.
  This release of Regina should now be fully Y2K compliant.
  See additions to the demo program; dateconv.rexx, for Y2K examples.
o Addition of RexxSetHalt() API function.
o Several API changes to enable Regina to be used with JP Software's
  4NT and TCMD32 products.  You will require a version of 4NT > 3.01
  or a version of TCMD32 > 2.01 for the Regina support.  See
  http://www.jpsoft.com for further details.

Please report any bugs with this release of Regina to me, NOT to Anders.
Most likely the bugs are of my origin, so I will attempt to fix them.
As with previous bugs fixed by me, I will pass these fixes on to Anders.

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                 Email:             M.Hessling@qut.edu.au
 PO Box 203                    Phone:                    +617 3802 0800
 Bellara                          http://www.lightlink.com/hessling/
 QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 Australia                     ************* Author of THE ************
+------------------------------------------------------------------------
                         Regina 0.08c
                         22 July 1997


Changes in this release (from 0.08b)
------------------------------------

o fixed error with divide by zero under Win32 port
o Changed regina executable.  In previous 0.08 releases, the regina
  executable was a front end to the Rexx SAA API, and used the RexxStart()
  function to start the interpreter.  One of the drawbacks with this
  method of executing a Rexx program is that only 1 parameter could be
  passed (from the command line) to regina. eg.
    % regina test.rex a b c
  would in fact fail!
  You needed to run:
    % regina test.rex "a b c"
  Another problem with this method of calling RexxStart() is that the
  default environment is assumed to be other than the operating system
  from which regina was called. What this resulted in was execution
  of operating system commands did not work as expected. eg.
    /**/
    'copy' file1 file2
  would fail because the default environment did not know what to do with
  'copy'. One had to use the following:
    /**/
    Address Command 'copy' file1 file2
  This problem has also been rectified in this release.
o Fixed an error with the DATE() conversion to Weekday format.  It would
  always return the current day of the week rather than the day of the
  week for the supplied date.
o Fixed a problem with the configure script under Un*x where the
  generated Makefile was incorrect for compilers that do not allow
  -c and -o together.
o The sample external function packages under Win95/NT were compiled
  incorrectly and failed to work.  These are now correct.
o Several changes were made to the API to conform more closely to the
  SAA API.  The most significant was to the return value parameter in
  the RexxStart() function.
o The configure script has been changed in this release to test for
  the GNU loader.  If your machine does not have the GNU loader, it is
  likely that you will get some "strange" errors displayed in the
  middle of the execution of the configure script.  Just ignore them.
o Minor changes to some of the scripts in "trip" to correct errors in
  BIF fixed in 0.08b.

------------------------------------------------------------------------
 This release will be the last until changes made by Les Moull are
 incorporated.
------------------------------------------------------------------------

Please report any bugs with this release of Regina to me, NOT to Anders.
Most likely the bugs are of my origin, so I will attempt to fix them.
As with previous bugs fixed by me, I will pass these fixes on to Anders.

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                 Email:             M.Hessling@qut.edu.au
 PO Box 203                    Phone:                    +617 3802 0800
 Bellara                          http://www.lightlink.com/hessling/
 QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 Australia                     ************* Author of THE ************
+------------------------------------------------------------------------
                         Regina 0.08b
                         20 June 1997


Changes in this release (from 0.08a)
------------------------------------

o fixed error in pos() and lastpos() BIFs
  pos('','abc') and lastpos('','abc') now correctly return 0 and not 1
o fixed major problem with long strings (> 2040 characters)
  This was in fact an error introduced in 0.08a (0.07a was fine)
  In fact the fix is to use the memory.c file from 0.07a
o Minor changes to autoconf, configure script to find the ANSI C
  compiler; c89, before reverting to a potentially non-ANSI compiler;
  cc.

Please report any bugs with this release of Regina to me, NOT to Anders.
Most likely the bugs are of my origin, so I will attempt to fix them.
As with previous bugs fixed by me, I will pass these fixes on to Anders.

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                 Email:             M.Hessling@qut.edu.au
 PO Box 203                    Phone:                    +617 3802 0800
 Bellara                          http://www.lightlink.com/hessling/
 QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 Australia                     ************* Author of THE ************
+------------------------------------------------------------------------
                       Regina 0.08a
                      10 April 1997

This is an "unofficial" release of the Regina Rexx Interpreter.

The "unofficial" status is due to the fact that I am not the author
nor the maintainer of this product.  The author, Anders Christensen,
will not be surprised by this release, as I had indicated to him in
September 1996, that I would be releasing this version. Most of the
enhancements and fixes I made to Regina 0.07a (and which are
incorporated in this release) were sent to Anders in August 1996,
in the hope that he would be able to make an official release.
As he has yet to do that I took it upon myself to enable
others to benefit from the enhancements I have made to Regina.

Explanation over; what's been done.

Apart from several bug fixes, particularly in the API, this release
include the following enhancements:

o added new built-in functions per the ANSI standard:
  countstr(), changestr()
o modified the date() and time() functions, again per the ANSI
  standard to support date and time conversions
o enhanced the API to support external functions residing in shared
  or synamic libraries, that can be loaded with the rxfuncadd()
  built-in function.  Although Regina 0.07a could also do this, you
  had to write your external function package in a way that only
  Regina would recognise.  External function packages built for OS/2
  can be ported simply to Regina.
o ported Regina to Win32 and supplied it as a DLL.
o added a DOS VCPI port (built using emx) that can be run under OS/2
  and under DOS without the need for a DPMI memory manager.
o shared libraries of Rexx external functions are now supported under
  several Un*x platforms.  The rexx library can be built as a static
  or dynamic library.
o modified the source for the Regina curses external function package to
  conform to a "standard" use of the API.  This curses external function
  package can be built with XCurses (my port of PDCurses to X11)
  enabling a Rexx program to display and control a native X11 window.

Please report any bugs with this release of Regina to me, NOT to Anders.
Most likely the bugs are of my origin, so I will attempt to fix them.
As with previous bugs fixed by me, I will pass these fixes on to Anders.

Cheers, Mark.
------------------------------------------------------------------------
 Mark Hessling                 Email:             M.Hessling@qut.edu.au
 PO Box 203                    Phone:                    +617 3802 0800
 Bellara                          http://www.lightlink.com/hessling/
 QLD 4507                      **** Maintainer PDCurses & REXX/SQL ****
 Australia                     ************* Author of THE ************
+------------------------------------------------------------------------
Welcome to version 0.07a of the Regina Rexx interpreter.

But first, the copyright and copying conditions. The code is
'copylefted', which means that it is copyrighted, but that you are
allowed to use, copy, modify, redistribute and sell the code, under
the conditions listed in the "GNU Library General Public License". See
the file COPYING-LIB for more information.

Note that this has changed since version 0.06, which was covered by
the 'ordinary' GPL. The reason for the change is simply that Regina is
becoming more and more library-like, and the LGPL seemed more
appropriate than the GPL.

The source has been built and tested on several platforms. Generally,
'all' you need a Standard C compiler (i.e. ANSI C), a 'lex' program
and a 'yacc' program. In addition, your machine should be POSIX
compliant. The latest version of Regina is stored on the anonymous ftp
site ftp.pvv.unit.no (129.241.36.200), in the '/pub/regina' directory.

To build the interpreter:

1) Edit the Makefiles (in particular the one in the 'src' subdirectory,
   and uncomment a suitable definition of the macros CC and CEXTRA.
   You may want to make a new one if none of the existing ones fit
   your exact needs.

2) Run the command   make

   If you like to make the dynamic library curses.rxlib, then you must
   issue the command  make curses.rxlib  while in the src subdirectory.
   Note that dynamic loading of libraries will not work on all systems.

3) The Makefile does not install targets. There is a make-target
   'install', which installs programs. Check the settings of macros in
   the makefile before running make for target 'install'.

4) You might want to run the documentation through the LaTeX
   textformatter.  If you don't have the 'block' and 'a4' style
   options for tex (these are not standard LaTeX options), just
   edit them out, letting the first line become:

      \documentstyle{report}

   Preformatted version of the documentation is supposed to be
   available from flipper in the directory 'pub/rexx/doc', there is
   one file which contains the whole documentation as a PostScript
   document. In addition, there is a set of ASCII files, which is the
   preformatted version, divided by chapters.

There are sometimes problems when compiling Regina under SunOS. The
main problem is that SunOS is one of few Unix systems still in use which
is neither POSIX nor ANSI. Note that Solaris is OK. But SunOS 4.1.1 has
the following problems:

 * Lacks the memmove() function; use bcopy() instead
 * Lacks the strerror() function; access sys_errlist[] directrly for
   circumvent this.

There are several other omisions and bugs in the include file of SunOS,
but the rest of them are likely to 'just' generate warnings. The two
above, however, _must_ be fixed if compilation shall succeed. If the
preprocessor symbol SunKludges is defined, these two problems are
automatically fixed in config.h; however, that fix may not suit all
situations.

In general, this depends on the interpreter you are using. Some
versions of gcc (at least 2.5.2) will declare strerror() and
memmove(); thus an error is provoked if compiled with SunKludges.
Also, there are some other problems, like the SEEK_{SET,END,CUR}
macros not being defined.

Also, SunOS has a bug, the _file member of FILE has type char, but
fileno() should return an integer or -1 if error. However, if your
max-number-of-files limit exceeds 128, fileno() will return -128 as
file descriptor. Obviously, this is incorrect, and obviously, this can
not be fixed by casting fileno() to unsigned char (it would be
incompatible and then -1 and 255 would overlap). You should (a)
complain about this to your SunOS vendor, and (b) never set the max
open files limit higher than 128. I've tried to circumvent it by
casting the return value from fileno to unsigned char. But it doesn't
seem to work, probably because other I/O functions use _file without
taking any precautions. Thus, you should never use max open files
greater than 128 under SunOS; else, bad things will happen, both in
Regina and in other programs. (Use limit or ulimit to display/set
this max limit.)

If you want to compile it for VMS, you need a lex and a yacc program.
You can get the GNU versions of these tools, or you can run the lex
and yacc on another machine, and copy the results of these programs
from that machine. Unfortunately, I've not been able to test the VMS
version for some time now, so it might need some 'help' to compile
correctly.

I have built it on the following platforms:

   - gcc, lex and yacc on a Uniline 88
   - gcc, lex and yacc on Sun 3
   - c89 (unbundled), lex and yacc on Decstation 5000, under Ultrix 4.2
   - cc, lex and yacc on Irix Indigo and Onyx, under IRIX 4 and 5
   - acc (unbundled), lex and yacc on Sun Sparc, under Sunos 4.2
   - cc, lex and yacc on Decstation 3100, under OSF/1
   - c89, lex and yacc on HP 9000, under HP/UX 8.05
   - cc, lex and yacc on IBM RS6000 under AIX
   - cc, lex and yacc on Cray under UNICOS
   - cc, lex and yacc on Linux 0.99
   - cc on a VAX/VMS, getting yacc and lex output from a Sun.
   - cc, lex and yacc on a DEC alpha running OSF/1

Read the file README.VMS to get more information about how to build
Regina on a computer running VMS, and what functionality is present in
the VMS version of Regina. In addition to VMS and Unix, this version
of Regina has also been successfully built for OS/2 and MS-DOS, using
the EMX development environment under OS/2. However, Regina does not
yet have any specific support for these systems.

This version of Regina also has support for dynamic loading of object
files. I.e. that you can load an object module containing definitions
for extra 'built-in' functions. This interface uses the same interface
as the RXFUNCADD(), RXFUNCDROP() and RXFUNCQUERY() functions in SAA
Rexx. Only one library of extra functions are available, it is a
curses interface library (although not all curses functions are
implemented in it yet.) To load these function into the interpreter,
use:

   lib = './curses.rxlib'
   if rxfuncadd('CURSES', '/path/curses.rxlib', 'curses')  then do
      say 'An error occured when trying to load the library: "'lib'"'
      say 'The error message returned was: "'rxfuncerrmsg()'"'
      say 'Exiting...'
      exit
      end
   else
      call curses('CUR_')

Actually, this 'just' loads and executes a function CURSES() in the
library. However, this special function will load all the other
functions in the library. The parameter given to CURSES() is the
prefix to prepend on all function names. See the file hanoi.rexx in
the code directory for an example.

Note that dynamic linking is only supported for those. Also note the
the normal 'make' setup will not by default compile the curses
library. To do that, do:

   make curses.rxlib

after having made the rest of Regina.

If you are unable to get Regina to work on your computer, because you
don't have one or several of the programs needed to build it, you can
try to build the GNU tools on your computer. Regina will compile with
these tools (and using them is a good idea anyway). You can get them
by anonymous ftp from prep.ai.mit.edu, ugle.unit.no and several other
places.

The areas where it is not POSIX compliant are:

   - It uses "struct timeval" and gettimeofday().  You can control
     this through the HAS_TIMEVAL option in config.h.  Comment it out
     if your machine does not eat the code.  Consequences: The
     interpreter will have a time granularity of 1 second.

   - It uses ftruncate().  If you do not have that, comment out the
     HAS_FTRUNCATE option on config.h.  Consequences: When writing to
     the middle of a file with lineout(), the file will not be
     truncated after the line written.

   - It uses putenv() to set an environment variable. While POSIX do
     have the getenv() call, it does not have a way of setting
     environment variables. Fortunately, most machines have a way of
     doing this, but you might have to link in an extra library or
     something. If you can't find a putenv() on your machine, you can
     undefine the HAS_PUTENV macro in config.h.  Consequences: Trying
     to set en environment variable will cause a syntax error

The interpreter has bugs and missing feature. I consider this release
of Regina a beta release, and I will continue to do so, until:

   - Regina is a full implementation of Rexx as described in the book:
     "The Rexx Language", by Mike Cowlishaw;

   - the most important extensions from CMS have been implemented;

   - a full implementation of the Rexx SAA API, as documented for
     OS/2, has been implemented;

   - all important extensions suggested by the ANSI Rexx committee
     have been implemented;

   - an extensive test suite which test most parts of the features
     listed above have been implemented, and Regina is able to run it
     without problems; and

   - the documentation for Regina has been completed.

If you find bugs or incompatibilities, please send me e-mail
describing the bug. It is important that your bugreport contains:

   - Description of what equipment you used, i.e. hardware
     platform, operating system, compiler version, compiler
     options used, version of Regina etc.

   - A description of the buggy behavior (and the behavior that
     you expected to see).

   - Preferably a program that demonstrates the behavior.  The
     program should be as small as possible, preferably not more
     than 10 lines or so.

   - If you have already fixed the bug, please append a context
     diff of the changes you made to the source.

Please make sure that the bug is really a bug in the interpreter, not
just a bug in your program. And also make sure that you've got the
latest release of Regina. If possible, run your program on other REXX
interpreters to see how they behave, and check with a REXX manual if
you have access to one. Bugreports are welcome, as well as other types
of comments. You can send bugreports directly to my email address,
listed below.

There are four subdirectories.

   - The first is 'trip' which is the start of a "triptest" for a REXX
     interpreter, which is supposed to test most REXX interpreter
     features.  If enough tests are gathered in this triptest, any
     REXX interpreter that manages to run it would be fairly REXX
     compatible. Such a trip test is not a perfect way of ensuring
     compatibility, but it is far better than none.

   - The next subdirectory is the 'demo', which contains some small
     demo programs for REXX, mainly demonstrations of special
     programming features in REXX. Also included are some common test
     programs and routines distributed on the net. Note that the
     programs in this directory are not covered by the GPL.

   - The src directory, containing the source code for Regina.

   - The 'doc' subdirectory, containing the documentation for Regina.
     Unfortunately, this documentation is not complete, nor it is
     completely correct at the moment, since I want to finish the
     coding before continuing the work in the doc.

Some of the things the interpreter does not have:

   - The documentation is far from finished. It has lower priority
     for the moment, until I have finished the interpreter itself.

   - For the (external) commands, there is not a consistent shell in
     the background to which commands are sent.  Instead either there
     is a shell that is started up each time (ADDRESS SYSTEM), or the
     command is run directly (ADDRESS PATH and COMMAND).  This will
     be fixed ...

   - I still need to test a lot of functionality that has been
     implemented and are supposed to work.

   - Lots of other things ...

There is a mailing list for announcements of new versions of Regina.
If you want to be on that list, send a request to be put on the list
to the address: <rexx-request@pvv.unit.no>

Anders Christensen                     e-mail: anders@pvv.unit.no
SINTEF RUNIT
Hogskoleringen 7i
N-7034 Trondheim, Norway
